#include "Browse For Folder.h"

// get folder path into a text box.
void GetFolderPath(HWND hwndOwner,HWND hwndTextBox)
{
	char pstrDir[MAX_PATH];

	// select a folder
	if ( SelectFolder(pstrDir,NULL,hwndOwner) == TRUE )
		SetWindowText(hwndTextBox,pstrDir);// if folder path is selected then set it to text box.
}
BOOL SelectFolder(LPTSTR pszSelectedDir,LPTSTR szCaption,HWND hOwner)
{
    //The BROWSEINFO struct Contains parameters for the SHBrowseForFolder function .
	BROWSEINFO      browseInfo;

    BOOL            bValid = FALSE; 
	
	//fill browseInfo (BROWSEINFO struct) with zeros
	ZeroMemory(&browseInfo, sizeof(BROWSEINFO));

    browseInfo.ulFlags =  BIF_RETURNFSANCESTORS;
	browseInfo.hwndOwner= hOwner;
	browseInfo.lpszTitle= szCaption;
  
	// show  the browse for folder dialog box 
	LPITEMIDLIST pIDL = SHBrowseForFolder(&browseInfo);

   if(pIDL != NULL)
   {
	    // get the path of selected folder  
	   if((SHGetPathFromIDList(pIDL,pszSelectedDir)) != 0) 
            bValid = TRUE;
		  
	      //free the item id list allocated by SHBrowseForFolder
		  CoTaskMemFree(pIDL);
    }

    return(bValid);
}
// A project by Muhammad Arshad Latti

