#include "CStrList.h"

CStrList::CStrList(void)
{
	m_sliFirst = NULL;
	m_iCount   = 0;		
}

CStrList::~CStrList()
{
 if (m_sliFirst)
 {
	 for (int i = 0;i < m_iCount;i++)
			Remove(0);
 }
}

BOOL CStrList::AddItem(LPSTR szItemKeyString,LPSTR szItemDataString)
{
	STR_LIST_ITEM * sliItem;
	STR_LIST_ITEM * sliLastItem;

	size_t ccKey  = strlen(szItemKeyString);
	size_t ccData = strlen(szItemDataString);
	
	ccKey++;
	ccData++;

	try	{
		sliItem = new STR_LIST_ITEM;
		if (!sliItem)
			 return FALSE;

		sliItem->szItemKeyString  = new char[ccKey];
			if (!sliItem->szItemKeyString)
			{
				delete sliItem;
				return FALSE;
			}

		sliItem->szItemDataString = new char[ccData];
			if (!sliItem->szItemDataString)
			{
				delete [] sliItem->szItemKeyString;
				delete sliItem;
				return FALSE;
			}
		strcpy(sliItem->szItemKeyString,szItemKeyString); 
		strcpy(sliItem->szItemDataString,szItemDataString); 
	}
	catch(...){
		return FALSE;
	}

	if (m_sliFirst)
	{
		sliLastItem = GetItem(m_iCount - 1);
		if (sliLastItem)
		{
		sliLastItem->sliNext = sliItem;
		
		sliItem->sliPrevious = sliLastItem;
		sliItem->sliNext	 = NULL;
		m_iCount++;
		return TRUE;
		}
	}
	else
	{
		sliItem->sliNext	 = NULL;
		sliItem->sliPrevious = NULL;
		m_sliFirst = sliItem;
		m_iCount = 1;
		return TRUE;
	}
	return FALSE;
}

BOOL CStrList::AddItem(LPSTR szItemKeyString,LPSTR szItemDataString,int iIndex)
{
//if (iIndex == 0 && m_sliFirst == NULL)
//		return AddItem(szItemKeyString,szItemDataString);		
return FALSE;
}

BOOL CStrList::Remove(int iIndex)
{
	STR_LIST_ITEM * sliItem;
	STR_LIST_ITEM * sliPreItem;
	STR_LIST_ITEM * sliNextItem;

	sliItem = GetItem(iIndex);

	if( sliItem )
	{
		sliPreItem  = sliItem->sliPrevious;
		sliNextItem = sliItem->sliNext;
		if (sliNextItem)
			sliNextItem->sliPrevious = sliPreItem;
		if (sliPreItem)
			sliPreItem->sliNext =sliNextItem;
		if (iIndex == 0)
				m_sliFirst = sliNextItem;

		delete [] sliItem->szItemKeyString;
		delete [] sliItem->szItemDataString;
		delete sliItem;
		m_iCount--;
		return TRUE;
	}
	return FALSE;

}
int  CStrList::Count(void)
{
	return m_iCount;
}

LPSTR CStrList::GetItemKey(int iIndex)
{
	STR_LIST_ITEM * sliItem;

	sliItem = GetItem(iIndex);

	if( sliItem )
		return sliItem->szItemKeyString;

	return NULL;
}

LPSTR CStrList::GetItemData(int iIndex)
{
	STR_LIST_ITEM * sliItem;

	sliItem = GetItem(iIndex);

	if( sliItem )
		return sliItem->szItemDataString;

	return NULL;
}

BOOL  CStrList::SetItemKey(int iIndex,LPSTR szItemKeyString)
{
return FALSE;
}
BOOL  CStrList::SetItemData(int iIndex,LPSTR szItemDataString)
{
return FALSE;
}

STR_LIST_ITEM * CStrList::GetItem(int iIndex)
{
	
	if (iIndex < 0 || iIndex > m_iCount - 1)
			return NULL;

	STR_LIST_ITEM * sliItem;

	sliItem = m_sliFirst;
	for (int i = 1;i <= iIndex;i++)
	{
		sliItem = sliItem->sliNext;
			if (!sliItem)
				return NULL;
	}
	return sliItem;
}
// A project by Muhammad Arshad Latti