#pragma once
#include <Windows.h>
#include <commctrl.h>
#include <shlwapi.h>

#include "Browse For Folder.h"
#include "CStrReplaceAll.h"
#include "String Definition.h"
#include "resource.h"

#pragma comment( lib, "comctl32.lib" )//COMCTL32.DLL
#pragma comment( lib, "shlwapi.lib" )//shlwapi.dll

void UpdateAllText(void);
void CatAndSet(LPSTR szSrc,LPSTR szCat,int iDlgItem);

BOOL CheckEntries(void);
int GetTextLen(int iDlgItemID);

void MakeFilesList(CStrList * slFiles);
void AddFileItem(CStrList * slFileList,int iDlgItemId,LPSTR szSourceFile);
void AddFileItem(CStrList * slFileList,LPSTR szSourceFile,LPSTR szOutputFile);

void MakeReplaceList(CStrList * slReplace);
BOOL CreateOutputDir(void);
BOOL CreateTemplateProject(void);

INT_PTR CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);
INT_PTR CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

//============================== Optional =========================================================
//Keep size small of executable by dynamic linkage of C run-time library 
//Caution : using "MSVCRT.LIB" program will need MSVCRT.DLL(vc++ 6) or MSVCP71.DLL(vc++ 2003) to run.
//#pragma comment(linker, "/nodefaultlib:libc.lib")//Disable C run-time library static linkage.
//#pragma comment(linker, "/defaultlib:MSVCRT.LIB")//Link dynamic C run-time library {msvcrt.dll). 

//Disable fast load future for Window 98 and program size will get smaller.
//#pragma comment(linker, "/OPT:NOWIN98")
//=================================================================================================
// A project by Muhammad Arshad Latti