#include <Windows.h>

//Index is zero based ("int iIndex")

//Data type identification 
//#define LPSTR char *
//#define BOOL int
//#define NULL 0

struct STR_LIST_ITEM
{
	STR_LIST_ITEM * sliPrevious;
	STR_LIST_ITEM * sliNext;
	LPSTR szItemKeyString;
	LPSTR szItemDataString;
};

class CStrList
{
	private:
	STR_LIST_ITEM * m_sliFirst;
	int m_iCount;

	public:
		CStrList(void);
		~CStrList();
		BOOL AddItem(LPSTR szItemKeyString,LPSTR szItemDataString);
		BOOL AddItem(LPSTR szItemKeyString,LPSTR szItemDataString,int iIndex);
		BOOL Remove(int iIndex);
		int  Count(void);

		LPSTR GetItemKey(int iIndex);
		LPSTR GetItemData(int iIndex);

		BOOL  SetItemKey(int iIndex,LPSTR szItemKeyString);
		BOOL  SetItemData(int iIndex,LPSTR szItemDataString);
		private:
			STR_LIST_ITEM * GetItem(int iIndex);
};
// A project by Muhammad Arshad Latti